import { TextDocument } from "vscode-json-languageservice";
import { CodeLens, CompletionItem, CompletionItemKind, Position, Range } from "vscode-languageserver-types";
import { SwfLanguageServiceArgs } from "./SwfLanguageService";
import { ShouldCreateCodelensArgs, CodeCompletionStrategy, ShouldCompleteArgs, SwfLsNode, TranslateArgs } from "./types";
export declare class SwfYamlLanguageService {
    private readonly ls;
    private readonly codeCompletionStrategy;
    constructor(args: Omit<SwfLanguageServiceArgs, "lang">);
    parseContent(content: string): SwfLsNode | undefined;
    getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    getCodeLenses(args: {
        content: string;
        uri: string;
    }): Promise<CodeLens[]>;
    getDiagnostics(args: {
        content: string;
        uriPath: string;
    }): Promise<import("vscode-languageserver-types").Diagnostic[]>;
    dispose(): void;
}
export declare const isNodeUncompleted: (args: {
    content: string;
    uri: string;
    rootNode: SwfLsNode;
    cursorOffset: number;
}) => boolean;
export declare class YamlCodeCompletionStrategy implements CodeCompletionStrategy {
    translate(args: TranslateArgs): string;
    formatLabel(label: string, completionItemKind: CompletionItemKind): string;
    getStartNodeValuePosition(document: TextDocument, node: SwfLsNode): Position | undefined;
    shouldComplete(args: ShouldCompleteArgs): boolean;
    shouldCreateCodelens(args: ShouldCreateCodelensArgs): boolean;
}
//# sourceMappingURL=SwfYamlLanguageService.d.ts.map