import { Position, TextDocument } from "vscode-languageserver-textdocument";
import { CompletionItemKind, Range } from "vscode-languageserver-types";
import { SwfLanguageServiceCommandTypes } from "../api";
export declare type SwfJsonPath = (string | number)[];
export declare type SwfLsNodeType = "object" | "array" | "property" | "string" | "number" | "boolean" | "null";
export declare type SwfLsNode = {
    type: SwfLsNodeType;
    value?: any;
    offset: number;
    length: number;
    colonOffset?: number;
    parent?: SwfLsNode;
    children?: SwfLsNode[];
};
export interface ShouldCompleteArgs {
    root: SwfLsNode | undefined;
    node: SwfLsNode | undefined;
    path: SwfJsonPath;
    content: string;
    cursorOffset: number;
}
export interface ShouldCreateCodelensArgs {
    content: string;
    node: SwfLsNode;
    commandName: SwfLanguageServiceCommandTypes;
}
export interface TranslateArgs {
    completion: object | string;
    completionItemKind: CompletionItemKind;
    overwriteRange?: Range;
}
export interface CodeCompletionStrategy {
    translate(args: TranslateArgs): string;
    formatLabel(label: string, completionItemKind: CompletionItemKind): string;
    shouldComplete(args: ShouldCompleteArgs): boolean;
    getStartNodeValuePosition(document: TextDocument, node: SwfLsNode): Position | undefined;
    shouldCreateCodelens(args: ShouldCreateCodelensArgs): boolean;
}
//# sourceMappingURL=types.d.ts.map